#ifndef FLUSS_H
#define FLUSS_H

#include <vector>
#include <list>
#include <string>
#include "Geometry.h"

using namespace std;

class Flussteil
{ 
  public:
    BoundingBox bb;
    vector<Point> V;

    template <class Iterator>
    Flussteil( Iterator first, Iterator beyond)
    { copy(first,beyond,back_inserter(V) ); }

    Flussteil(const vector<Point> &U)
    { V = U; }
};

class Fluss
{ 
  public:
    string name;
    BoundingBox bb;
    list<Flussteil> L;
    bool visible;
    bool mark;

    template <class FlussteilIterator>
    Fluss( FlussteilIterator first, FlussteilIterator beyond)
    {
      copy( first, beyond, back_inserter(L));
      visible = true;
      mark = false;
    }

    Fluss()
    { 
      visible = true;
      mark = false;
    }

    void add(const Flussteil &FT)
    { L.push_back(FT); }
};

#endif
