#include <fstream>

///
using namespace std;

/// Eine einfache Klasse fr Punkte im R^2
class Point
{ 
  public:
  ///
  double x;
  ///
  double y;
  ///
  
  ///
  friend bool operator< (const Point& p,const Point& q)
  { 
    if (p.x < q.x) return true;
    if (p.x > q.x) return false;
    if (p.y < q.y) return true;
    return false;
  }
  ///
  friend istream& operator>> (istream& is, Point& p)
  {
    is >> p.x >> p.y; 
    return is;
  }

  ///
  friend ostream& operator<< (ostream& os, const Point& p)
  {
    os << p.x << "  " << p.y;
    return os;
  }
}///
;

/** Eine Klasse zur Berechnung von umschlieenden Rechtecken 
    fr Punktmengen
*/
class BoundingBox
{
  public:

  /// linke untere Ecke
  Point min;
  /// rechte obere Ecke
  Point max;

  ///
  BoundingBox()
  {
    min.x = min.y =  1e100;
    max.x = max.y = -1e100;
  }

  /// gibt die Bounding Box aus 
  friend ostream& operator<< (ostream& os, const BoundingBox& bb)
  {
    os << "[" << bb.min.x << "," << bb.max.x << "]" 
       << " x [" << bb.min.y << "," << bb.max.y << "]" << endl; 
    return os;
  }
}///
;

class EnlargeBB
{
  public:
    EnlargeBB( BoundingBox& b) : bb(b) {}

    void
    operator()(const Point& p)
    {
      if (p.x < bb.min.x) bb.min.x = p.x;
      if (p.y < bb.min.y) bb.min.y = p.y;
      if (p.x > bb.max.x) bb.max.x = p.x;
      if (p.y > bb.max.y) bb.max.y = p.y;
    }

  private:
    BoundingBox& bb;
};


class AddToBB
{
  public:
    BoundingBox
    operator()( const BoundingBox& b, const Point& p)
    {
      BoundingBox bb = b;
      if (p.x < bb.min.x) bb.min.x = p.x;
      if (p.y < bb.min.y) bb.min.y = p.y;
      if (p.x > bb.max.x) bb.max.x = p.x;
      if (p.y > bb.max.y) bb.max.y = p.y;
      return bb;
    }
};
