#ifndef GLUT_ADMIN_H
#define GLUT_ADMIN_H

#include <GL/glut.h>

/// Eine Basisklasse fr Fenster mit Callback-Funktionalitt
class GlutWindow
{ 
protected:

   ///
   int ID;

public:

   ///
   GlutWindow() {}
   ///
   virtual ~GlutWindow() {}

   ///
   virtual void DisplayFunc() {}
   ///
   virtual void MotionFunc(int,int) {}
   ///
   virtual void MouseFunc(int,int,int,int) {}
   ///
   virtual void ReshapeFunc(int,int) {}
   ///
   virtual void IdleFunc() {}
   ///
   virtual void MenuFunc(int) {}

   ///
   void    SetWindowID(int newID) { ID = newID; }
   ///
   int     GetWindowID() { return ID; }

}///
;


/// Eine Klasse zur Verwaltung der glut-Events
class GlutAdmin{

private:

   /// statisches Feld zur Verwaltung aller Fenster eines Programms
   static GlutWindow *glutwin[];

   /// 
   static void DisplayFunc()
   {
      int ID = glutGetWindow();
      glutwin[ID]->DisplayFunc();
   }

   ///
   static void MotionFunc(int x,int y)
   {
      int ID = glutGetWindow();
      glutwin[ID]->MotionFunc(x,y);
   }

   ///
   static void MouseFunc(int button,int state,int x,int y)
   {
      int ID = glutGetWindow();
      glutwin[ID]->MouseFunc(button,state,x,y);
   }

   ///
   static void ReshapeFunc(int w,int h)
   {
      int ID = glutGetWindow();
      glutwin[ID]->ReshapeFunc(w,h);
   }

   ///
   static void IdleFunc()
   {
      int ID = glutGetWindow();
      glutwin[ID]->IdleFunc();
   }

public:

   ///
   static void MenuFunc(int value)
   {
      int ID = glutGetWindow();
      glutwin[ID]->MenuFunc(value);
   }
 
   ///
   GlutAdmin();
   ///
   ~GlutAdmin();
    
   /**  kreiert das Fenster window mit dem Namen title und sorgt fr den
        korrekten Aufruf der Callback-Funktionen Display, Reshape, etc.
   */
   void CreateWindow(char *title,GlutWindow *window);
   ///
   void MainLoop();

}///
;

#endif
