#include <cstdlib>
#include <cassert>
#include <string>
#include <iostream>
#include <numeric>
#include <algorithm>
// #include <minmax.h>
#include "VectorWindow.h"
#include "Fluss.h"

///
int 
main(int argc, char** argv)
{
  GlutAdmin  glutAdmin;

  VectorWindow vecwin(glutAdmin,400,400,200,100,"Vector");

  assert(argc == 2);

  ifstream F(argv[1]);
  string ende = "END";
  string flussname;
  char ch;
  string name;

  while (F >> flussname)
  {
    F.get(ch);
	while (ch != '\n')
	{
		F >> name;
		flussname += " " + name;
		F.get(ch);
	}

    vecwin.M[flussname].add(Flussteil( istream_iterator<Point>(F),
                                       istream_iterator<Point>() ));
    F.clear();
    F >> flussname;

    assert( flussname == ende); 
  }
  
  vecwin.M[string("Saar")].mark = true;  
  vecwin.M[string("Mosel")].mark = true;

  map<string,Fluss>::iterator it = vecwin.M.find(string("Ellbach"));
  if (it == vecwin.M.end())
	cout << "Ellbach zu klein" << endl;
  cout << "Zahl der Fluesse: " << vecwin.M.size() << endl;

  BoundingBox bb;

  map<string,Fluss>::iterator f;
  list<Flussteil>::iterator i;

  for(f=vecwin.M.begin(); f!=vecwin.M.end(); ++f)
    for(i=f->second.L.begin(); i!=f->second.L.end(); ++i)
      for_each(i->V.begin(), i->V.end(), EnlargeBB(bb));
     // bb = accumulate( i->V.begin(), i->V.end(), bb, AddToBB());

  vecwin.llcorner = bb.min;
  vecwin.scale = min(vecwin.width/(bb.max.x-bb.min.x),
	                 vecwin.height/(bb.max.y-bb.min.y));

  glutAdmin.MainLoop();

  return EXIT_SUCCESS;
}

